#include <algorithm>
#include <vector>
#include <iostream>
#include <string>
// Time start
#include <stdlib.h>
#include <time.h>
// Time end

#include "Student_info.h"
#include "grade.h"

//driver program for grade partitioning examples

using std::cin;
using std::cout;
using std::endl;
using std::sort;
using std::string;
using std::vector;

#ifdef _MSC_VER
#include "../minmax.h"
#else
using std::max;
#endif

vector<Student_info> extract(vector<Student_info>& students, bool criterion(const Student_info& s));

int main()
{
	// Time start
	long sek;
	time(&sek);
	//long ratio = 1000/CLK_TCK;
	clock_t time1, time2;		
	// Time end
	vector<Student_info> vs;
	Student_info s;
	string::size_type maxlen = 0;
	/*while (read(cin, s)) {
		maxlen = max(maxlen, s.name.size());
	vs.push_back(s);
    }*/
    Student_info temp;
    //string temp_string;
    temp.name = "Test";
    maxlen = max(maxlen, temp.name.size());
    temp.midterm = 60;
    temp.final = 50;
	temp.homework.push_back(50);
         
    for (unsigned int c = 0; c < 10000; ++c) {
    	vs.push_back(temp);
	}

    sort(vs.begin(), vs.end(), compare);
	// Time start
	time1 = clock();		
	// Time end
	vector<Student_info> fails = extract(vs, fgrade);
	// Time start
	time2 = clock();		
	// Time end
	for (vector<Student_info>::size_type i = 0; i < fails.size(); ++i)
		cout << fails[i].name << " " << grade(fails[i]) << endl;

	cout << ((long)(time2-time1))/CLOCKS_PER_SEC << endl;
	return 0;
}
